struct result APS1(struct param param, struct problem pb, struct result R,
                   int function) 
{
 struct vector around;
 struct position best;
 int confin=1; // Useless here. Just for compatibility with the Research version
 int d;
 int D; // Dimension of the search space
 double err;
 double factD;
 //double FEs;
 int i;
 int i1,i2,i3;
 int iBest;
 struct intDouble index[S_max];
 int index0[S_max];
 int iter;
 int j;
 struct matrix M;
 double max_FEs;
 double popCost;
 double pv;
 int quant;
 double radius;
 int randCase; // Define th RNG
 int rBest;
 int ri;
 int rWorst, rWorst2;
 double sVol[2];
 int sVolI;
 int S; // "swarm" size
 struct result Splx;
 int stopCondition;
 int tryMore;
 int uniform;
 struct position  x_c,x_l, x_r;
 double xMax[DMax], xMin[DMax];
 double zz;

 //------------------------------------------------------------ Check consistency
 D=pb.SS.D; // Dimension of the definition space
 S=param.S; // Population size

 if(S<D+1)
 {
	printf("\nTo apply the simplex method on this %i dimensions problem,",D);
	printf("\n you need at least %i individuals. There are only %i",D+1, S);
	ERROR("Sorry, I have to stop here");
 }

 if(D<=1)
 {
	ERROR("Sorry, I can't apply this APS version on 1D problems");
 }

 //------------------------------------------------------------------ Initialise
 // Note: the parameter R must already contain initial positions
 around.size=D;
 best.size=D;
 best.f=infinity;
 factD=fact(D); // D!
 iter=0;
 // Temporary result 
 Splx=R; // R contains S individuals (initialised before to call this subroutine)

 popCost=0; // Current "cost" of the population.
 // The aim is to decrease it
 for (i=0;i<S;i++) popCost=popCost+Splx.SW.X[i].f;

 quant=pb.SS.quantisation; // If the problem is discrete, at least on some
 // dimensions (see problemDef())
 randCase=param.randCase; // RNG. Default: 10 => Mersenne-Twister
 sVolI=0; // To switch between current simplex volume and previous one
 x_c.size=D;
 x_l.size=D;
 x_r.size=D;

 for(d=0;d<D;d++) // The search space may be normalised as [0,normalise]^D
	// (see problemDef.c)
	// Note: as we use a hypersphere, the search space should be
	// a hypercube. That is why it has sometimes to be normalised.					
 {
	if(pb.SS.normalise<=zero) { xMin[d]=pb.SS.min[d]; xMax[d]=pb.SS.max[d];}
	else {xMin[d]=0; xMax[d]=pb.SS.normalise;} 
 }

 sVolI=0;
 sVol[sVolI]=0;

 //----------
 err=pb.epsilon;
 max_FEs=pb.evalMax;
 tryMore=param.tryMore;
 FEs = R.nEval; // NOT zero, for there has been at least initialisation 
 // before the call

 // --------------------------------------------------------------- Simplex loop	

 stopCondition=0==1; // False to begin
 while (!stopCondition)
 { 
	for(i=0;i<S;i++) // Loop on individuals
	{
	 iter=iter+1; // Just for information
	 // Random permutation of the S individuals
	 aleaIndex(index0,S,randCase); // Result in index0 

	 // Be sure that the current individual IS in the random simplex
	 for(j=0;j<D+1;j++)
	 {
		if (index0[j]==i) goto select; // OK
	 }
	 //Not in.  Replace the last one by i
	 index0[D]=i;

	 select:
		// Select the D+1 first ones. They define the simplex
		for(j=0;j<D+1;j++)
	 {
		index[j].i=index0[j]; // Rank in Splx (which contains S individuals)
		index[j].d=Splx.SW.X[index0[j]].f; // Fitness value
	 }
		// Sort the 3 first ones(from the best to the worst)

		// C method
		// qsort(index,3,sizeof(index[0]), compareIntDouble);
		// 	 rBest=index[0].i; rWorst2=index[1].i; rWorst=index[2].i;

		//--- Hard way method
		i1=0; i2=1; i3=2;
		if(index[i2].d>index[i3].d)
	 {	j=i3; i3=i2; i2=j;}

		if(index[i1].d>index[i3].d)
	 { j=i3; i3=i1; i1=j;}

		if(index[i1].d>index[i2].d)
	 { j=i2; i2=i1; i1=j;}

		rBest=index[i1].i;
		rWorst2=index[i2].i;
		rWorst=index[i3].i;
		//---

		// Record the best 
		if(Splx.SW.X[rBest].f<best.f)
	 {
		best=Splx.SW.X[rBest];
		iBest=rBest;
	 }

		// ---------------------------------------Adaptive pv
	 // The idea is the following:
		// the more the simplex volume increases, the less it is successful
		// and the more one needs randomness to increase the diversity

		// ----------- Simplex volume
		// The simplex is defined by D+1 points, X1, X2, etc.
		M.D=D+1; // Each column i is Xi plus 1 at the bottom
		for(j=0;j<D+1;j++) // For each column ...
	 {
		for(d=0;d<D;d++) // ... for each line (i.e. each dimension
		{
		 ri=index[j].i;
		 M.m[d][j]=Splx.SW.X[ri].x[d];
		}
		// Last line
		M.m[D][j]=1;
	 }
		sVol[1-sVolI]=fabs(deter(M))/factD; // volume = abs(determinant(M)). This is a theorem 

		// Compute pv 	
		if(sVol[sVolI]<zero) pv=0;
		else pv = (sVol[1-sVolI]-sVol[sVolI])/sVol[sVolI]; 

		pv = 1./(1+exp(-pv)); // Logistic curve, so that pv is in [0,1]
		sVolI=1-sVolI;

		// ------------------------------ probabilistic Expansion (quasi-reflection)
		for(d=0;d<D;d++) // For each dimension ...
	 {
		if(alea(0,1,randCase)<pv) // ... either expand the coordinate ...
		 x_r.x[d] = Splx.SW.X[rWorst2].x[d] 
		 + Splx.SW.X[rBest].x[d]
		 - Splx.SW.X[rWorst].x[d];
		else 											// ... or keep it
		 x_r.x[d]=Splx.SW.X[i].x[d];
	 }

//Check for constraint violations
		 x_r=confinement(x_r,xMin,xMax,pb.SS,confin);
		 if(quant==1) x_r=quantis(x_r,pb.SS);
// Evaluation
		x_r = eval(x_r,xMin,xMax, pb.SS,confin, function, quant, pb.objective);

		// Record the best
		if(x_r.f<best.f)
	 {
		best=x_r;
		iBest=i;
	 }
		// ----------------------------First chance to improve the current individual
		if( x_r.f < Splx.SW.X[i].f) // If improvement, decrease the cost
	 {  
		popCost=popCost+x_r.f-Splx.SW.X[i].f; // Cost is decreasing
		Splx.SW.X[i]=x_r; // The current position is improved
	 }
		// if no improvement => try contraction (define x_c)
		if( x_r.f >= Splx.SW.X[i].f || tryMore>=1) 
	 {
		// Probabilistic Contraction 
		for(d=0;d<D;d++)
		{
		 if(alea(0,1,randCase)<pv) // Gravity center of the best, second worst, worst
			x_c.x[d] = (Splx.SW.X[rBest].x[d] 
			            + Splx.SW.X[rWorst2].x[d]
			            + Splx.SW.X[rWorst].x[d])/3;
		 else 
			x_c.x[d]=Splx.SW.X[i].x[d];
		}

		x_c=confinement(x_c,xMin,xMax,pb.SS,confin);
		 if(quant==1) x_c=quantis(x_c,pb.SS);
		x_c = eval(x_c,xMin,xMax, pb.SS,confin, function, quant, pb.objective);

		// Record the best
		if(x_c.f<best.f)  
		{
		 best=x_c;
		 iBest=i;
		}
	 } 
		//------------------------------------------------------ Second chance
		if( x_c.f < Splx.SW.X[i].f) // If improvement, decreases the cost
	 {  
		popCost=popCost+x_c.f-Splx.SW.X[i].f; 
		Splx.SW.X[i]=x_c; // Improved position
	 }
		// If no improvement, and if worse than average
		if(x_c.f >= Splx.SW.X[i].f || tryMore>=2)
		 			//                 perform a local search
		 if(Splx.SW.X[i].f>popCost/S)
	 {
		radius=0;
		for(j=0;j<S;j++) // Total population
		 // Maximum distance from the rBest
		{
		 if(j==rBest) continue; 
		 zz=distanceL(Splx.SW.X[rBest], Splx.SW.X[j],2);
		 if (zz>radius) radius=zz;
		}

		// Either uniform or non uniform distribution, at random
		if(alea(0,1,randCase)<0.5) uniform=0; else uniform=1;
		around=alea_sphere(D,radius,uniform,-1,-1,randCase);

		for(d=0;d<D;d++)  x_l.x[d]=Splx.SW.X[rBest].x[d]+around.v[d];

		x_l=confinement(x_l,xMin,xMax,pb.SS,confin);
		 if(quant==1) x_l=quantis(x_l,pb.SS);
		x_l = eval(x_l,xMin,xMax, pb.SS,confin, function, quant, pb.objective);

		// Record the best
		if(x_l.f<best.f) 
		{
		 best=x_l;
		 iBest=i;
		}

		// Modify the total cost
		popCost=popCost+x_l.f-Splx.SW.X[i].f;
		Splx.SW.X[i]=x_l; 

	 } //else // x_r.f > Splx.SW.X[ri].f

	} // for(i=0;i<S;i++) // Loop on individuals

	stopCondition=best.f <= err || FEs > max_FEs;
 } // while (stopCondition==false)

 Splx.error=best.f;
 Splx.nEval=FEs;

 /*
	// Useful only if APS is used as local search
	Splx.SW.best=iBest;
	Splx.SW.X[iBest]=best;
	*/
 return Splx;
} 
