
double alea (double a, double b, int option) 
{				// random number (uniform distribution) in  [a b]
	double r;

	switch(option)
	{
   case 1 : // KISS PRNG
   	r=randk()/KISS_PRNG_Max;
   break;
			
			default:  // Mersenne
			r=genrand64_real2();
			break;

      case -1: // Standard C	
			r=(double)rand()/RAND_MAX;
			break;
	}

	nbRand++;
	 r=a+r*(b-a);
	return r; 
}

//==================================================
void aleaIndex(int index[], int S,int option)
{
	int indexTemp[S_max];
	int length;
	int rank;
	int s;
	int t;

	length=S;
	for (s=0;s<S;s++) indexTemp[s]=s; //=index[s];

	for (s=0;s<S;s++)
	{	
			rank=alea_integer(0,length-1,option);
			index[s]=indexTemp[rank];
			if (rank<length-1)	// Compact
			{	
				for (t=rank;t<length-1;t++)
					indexTemp[t]=indexTemp[t+1];
			}					
			length=length-1;
	}
}
// ===========================================================
int alea_integer (int a, int b,int option) 
{				// Integer random number in [a b]
	int ir;
	double r;

	//r = alea (0, 1);
	//ir = (int) (a + r * (b + 1 - a));
	//if (ir > b)	ir = b;

	if(a==b) return a;
	r=alea((double)a,(double)b+1,option); ir=floor(r);

	if(ir>b) ir=b;

	return ir;  
}

// ===========================================================
double alea_normal (double mean, double std_dev,int option) 
{ 
	// Use the polar form of the Box-Muller transformation to obtain a pseudo
	// random number from a Gaussian distribution 

	double x1, x2, w, y1; 
	// WARNING. This method is valid only if alea (...) defines a (more or less)
	// uniform distribution. In particular, if "option" is so that the numbers are
	// read on a list, whose distribution is, say, Gaussian, then w will never be
	// smaller than 1 

int count=0;
	do  
	{
		x1 = 2.0 * alea (0, 1,option) - 1.0;
		x2 = 2.0 * alea (0, 1,option) - 1.0;
		w = x1 * x1 + x2 * x2; 
		count++;
		if(count>10000) //RAND_MAX)
		{
		if(option==4) printf("\n Random numbers read on a list");
		ERROR("alea_normal. Probable non uniform distribution for alea(...)");
		}
	}
	while (w >= 1.0); // WARNING. Infinite loop possible.  w may be _never_ < 1 !!
	  

	w = sqrt (-2.0 * log (w) / w);
	y1 = x1 * w;

	if(alea(0,1,option)<0.5) y1=-y1; 
	y1 = y1 * std_dev + mean;
	return y1;  
}

// ===========================================================
struct vector alea_sphere(int D, double radius, int distrib, double mean,
    double sigma,int option)
{
	/*  ******* Random point in a hypersphere ********
	 Maurice Clerc 2003-07-11
	 Last update: 2011-01-01

	 Put  a random point inside the hypersphere S(center 0, radius 1), 
	 or on its surface
		 */

	int 	j;
	double   length;
	double      pw;
	double      r;
	struct	vector	x;

	x.size=D;
	pw=1./(double)D;

	// ----------------------------------- Step 1.  Direction
	length=0;
	for (j=0;j<D;j++)
	{
		// Here a Gaussian distribution is needed

		x.v[j]=alea_normal(0,1,option);// Gaussian (Box-Muller method)
		length=length+  x.v[j]*x.v[j];
	}

	length=sqrt(length);
	//----------------------------------- Step 2. Random radius

	switch(distrib) 
	{
		default: // Uniform distribution
							// Note that the distribution in the hypersphere is NOT uniform
		case 0:
			r=alea(0,1,option); 
		break;

		case 1: // So that the final distribution is uniform in the sphere
		  r=alea(0,1,option); 
			r=pow(r,pw);
		break;
	} 


	for (j=0;j<D;j++)
	{
		x.v[j]=radius*r*x.v[j]/length;
	}
	return x;
}

//================================================
#include "KISS_PRNG.c"
#include "mersenne.c"
